#include "Kcommon.h"

//***********************************.
//returns a bitboard with all possible
//moves set
int generateMoves(struct position pos)
{
//board structure (bits):
// 6 7 8
// 3 4 5 
// 0 1 2

return (~(pos.board[noughts] |
			  pos.board[crosses] )) & 0x1ff;

}

//***********************************
//returns a bitboard with only the
//least significant bit of 'board' set
int getLSB(int board)
{
for (int i=0;i<9;i++)
	if (board & (1<<i)) return 1<<i;

return 0;
}

//***********************************
//make next move and remove move from
// movelist
int makeNextMove(struct position *pos, int *moves)
{
 if (*moves==0) return 0;

 int move=getLSB(*moves);
 
 pos->board[pos->side] |=move; //make move
 pos->side=!pos->side; //other side to move
 *moves &= 0x1ff^move;//remove move from movelist
 
 return 1;
}


