#include "Kcommon.h"
#include <stdlib.h>

int alphaBeta(struct position pos,int alpha, int beta);

//***********************************
int rootSearch(struct position *pos)
{
int alpha=-INFINITY;//the worst we can do
int beta=INFINITY;  //the best the enemy can do
int bestPos; //board for side with best move made
int possibleMoves= generateMoves(*pos);

if (possibleMoves==0) return 0;//no moves left!

//first move? - make things more interesting
if (pos->board[noughts]==0 && pos->board[crosses]==0)
 {
  possibleMoves=(int)(1<<(rand()%9));
  makeNextMove(pos,&possibleMoves);
  return 1;
 }

int value;
struct position backupPos=*pos;

while (possibleMoves)
{
 makeNextMove(pos,&possibleMoves);
 
 value = evaluate(*pos);
if (value==0) value =-alphaBeta(*pos,-beta,-alpha);
 if (value>alpha)
	 {
	  alpha=value; //new best score for us
	  bestPos=pos->board[!pos->side];
	 }
	 
*pos=backupPos; //unmake move
}

 //make best move
 pos->board[pos->side]=bestPos;
 pos->side=!pos->side;
return 1;
}

//***********************************
int alphaBeta(struct position pos,int alpha, int beta)
{
int possibleMoves= generateMoves(pos);

if (possibleMoves==0) return 0;//no moves left!

int value;
struct position backupPos=pos;

while (possibleMoves)
{
 makeNextMove(&pos,&possibleMoves);
 value = evaluate(pos);
 if (value==0) value =-alphaBeta(pos,-beta,-alpha);
if (value>0) return value; //end of game

 if (value>alpha)  alpha=value; 
 if (value>=beta) return value; 

pos=backupPos; //unmake move
}

return alpha;
}

//***********************************

