#include <windows.h>
#include "main.h"
#include "Kcommon.h"

HWND hwndMain;               /* This is the handle for our window */
struct position rootPos;
int    sideWon=-1;
bool   showResult=true;
unsigned int lastMove;

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
char szClassName[ ] = "WindowsApp";

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
//    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */
    HMENU menu;              /* Handle of the menu */
    
    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwndMain = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Knoughty",          /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           300,                 /* The programs width */
           300,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwndMain, nFunsterStil);

    menu = LoadMenu(hThisInstance, MAKEINTRESOURCE(ID_MENU));
    SetMenu(hwndMain, menu);
    
    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}

//------------------------------------------------------------------------------
void drawNought(int x,int y)
{     
 HDC hdc = GetDC(hwndMain);
 RECT rc;
 GetClientRect(hwndMain, &rc);    
 SelectObject(hdc, CreatePen(PS_SOLID, 2, RGB(0, 0, 255)));    
 SelectObject(hdc, CreateSolidBrush(RGB(0, 200, 0)));  

 int deltaX=rc.right/10;
 int deltaY=rc.bottom/10; 
 
 Ellipse(hdc, x-deltaX, y-deltaY, x+deltaX, y+deltaY);     
       
 ReleaseDC(hwndMain, hdc);         
}

//------------------------------------------------------------------------------
void drawCross(int x,int y)
{
 HDC hdc = GetDC(hwndMain);
 RECT rc;
 GetClientRect(hwndMain, &rc);    
 SelectObject(hdc, CreatePen(PS_SOLID, 2, RGB(255, 0, 0))); 
 

 int deltaX=rc.right/10;
 int deltaY=rc.bottom/10; 
 MoveToEx(hdc, x-deltaX,y-deltaY, NULL);
 LineTo(hdc,   x+deltaX,y+deltaY);   
 MoveToEx(hdc, x-deltaX,y+deltaY, NULL);
 LineTo(hdc,   x+deltaX,y-deltaY);
    
 ReleaseDC(hwndMain, hdc);  
}
//------------------------------------------------------------------------------
void drawBoard()
{
   HDC hdc = GetDC(hwndMain);
   RECT rc;
   GetClientRect(hwndMain, &rc);     
  
   FillRect(hdc, &rc, CreateSolidBrush(RGB(0, 200, 0)));  
   SelectObject(hdc, CreatePen(PS_SOLID, 2, RGB(50, 50, 50)));    

   int i;
   for (i=rc.right/3;i<rc.right-2;i+=(rc.right/3)) 
      {
       MoveToEx(hdc, i,0, NULL);
       LineTo(hdc, i,rc.bottom);   
      } 
      
   for (i=rc.bottom/3;i<rc.bottom-2;i+=(rc.bottom/3)) 
      {
       MoveToEx(hdc, 0,i, NULL);
       LineTo(hdc, rc.right,i);   
      } 
    
 if (rootPos.board[noughts]&0x001) drawNought(rc.right/6,5*rc.bottom/6);
 if (rootPos.board[crosses]&0x001) drawCross(rc.right/6,5*rc.bottom/6);
 if (rootPos.board[noughts]&0x002) drawNought(3*rc.right/6,5*rc.bottom/6);
 if (rootPos.board[crosses]&0x002) drawCross(3*rc.right/6,5*rc.bottom/6);
 if (rootPos.board[noughts]&0x004) drawNought(5*rc.right/6,5*rc.bottom/6);
 if (rootPos.board[crosses]&0x004) drawCross(5*rc.right/6,5*rc.bottom/6);
 if (rootPos.board[noughts]&0x008) drawNought(rc.right/6,3*rc.bottom/6);
 if (rootPos.board[crosses]&0x008) drawCross(rc.right/6,3*rc.bottom/6);
 if (rootPos.board[noughts]&0x010) drawNought(3*rc.right/6,3*rc.bottom/6);
 if (rootPos.board[crosses]&0x010) drawCross(3*rc.right/6,3*rc.bottom/6);
 if (rootPos.board[noughts]&0x020) drawNought(5*rc.right/6,3*rc.bottom/6);
 if (rootPos.board[crosses]&0x020) drawCross(5*rc.right/6,3*rc.bottom/6);

 if (rootPos.board[noughts]&0x040) drawNought(rc.right/6,rc.bottom/6);
 if (rootPos.board[crosses]&0x040) drawCross(rc.right/6,rc.bottom/6);
 if (rootPos.board[noughts]&0x080) drawNought(3*rc.right/6,rc.bottom/6);
 if (rootPos.board[crosses]&0x080) drawCross(3*rc.right/6,rc.bottom/6);
 if (rootPos.board[noughts]&0x100) drawNought(5*rc.right/6,rc.bottom/6);
 if (rootPos.board[crosses]&0x100) drawCross(5*rc.right/6,rc.bottom/6); 

 if (showResult)
    {
     if (evaluate(rootPos)!=0) 
        {
         sideWon=!rootPos.side;
         showResult=false;
         }
     if (sideWon==noughts) MessageBox (hwndMain, "Noughts won!" , "Result", 0);
     else if (sideWon==crosses) MessageBox (hwndMain, "Crosses won!" , "Result", 0);
     else if ((int)(rootPos.board[noughts] | rootPos.board[crosses])==0x1ff) 
          {                                         
           MessageBox (hwndMain, "It's a draw" , "Result", 0);                                            
           showResult=false;
          }                                           
     
     }                
/*else if ((int)(rootPos.board[noughts] | rootPos.board[crosses])==0x1ff)
		{
		sideWon=3;
        SetBkMode(hdc, TRANSPARENT); 
        SetTextColor(hdc, (RGB(0, 0, 0)));
		TextOut(hdc,3*rc.right/8,3*rc.bottom/6,"It's a draw!",12);  
		}
*/		
 ReleaseDC(hwndMain, hdc);            
}   

//------------------------------------------------------------------------------
/*  This function is called by the Windows function DispatchMessage()  */
LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 int x = LOWORD(lParam);
 int y = HIWORD(lParam);
 RECT rc;
 GetClientRect(hwndMain, &rc);      
 int maxX = rc.right;
 int maxY = rc.bottom;
 int move=0;


    switch (message)                  /* handle the messages */
    {
       case WM_COMMAND:
           switch( wParam )
           {
             case IDM_NEWNOUGHTS:
                    rootPos.board[noughts]=0;
                    rootPos.board[crosses]=0;
                    rootPos.side=crosses;
                    sideWon=-1;
                    showResult=true;
                    drawBoard();
                    rootSearch(&rootPos);
                    drawBoard();    
                    return 0;                 
             case IDM_NEWCROSSES:
                    rootPos.board[noughts]=0;
                    rootPos.board[crosses]=0;
                    rootPos.side=crosses;
                    sideWon=-1;
                    showResult=true;
                    drawBoard();  
                  return 0;

             case IDM_FILEEXIT:
                  SendMessage( hwnd, WM_CLOSE, 0, 0L );
                  return 0;

             case IDM_HELPABOUT:
                  MessageBox (hwndMain, "Noughts and Crosses Demo by www.mayothi.com" , "About",MB_OK);
                  return 0;
           }
           break;

      case WM_PAINT:
            PAINTSTRUCT ps;
            HDC hdcWindow;
            hdcWindow = BeginPaint(hwnd, &ps);
            drawBoard();          
            EndPaint(hwnd, &ps);
         break;
                    
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        case WM_LBUTTONUP:
         if (sideWon!=-1) break;
         if (y>31*maxY/48)
         	{
          	 if (x>31*maxX/48) move=0x004;
             else if (x>16*maxX/48) move=0x002;
             else move=0x001;
            }
         else  if (y>16*maxY/48)
          	{
           	 if (x>31*maxX/48) move=0x020;
           	 else if (x>16*maxX/48) move=0x010;
             else move=0x008;
            }
         else
           	{
           	 if (x>31*maxX/48) move=0x100;
           	 else if (x>16*maxX/48) move=0x080;
             else move=0x040;
            }

            if ((unsigned int)(( rootPos.board[noughts]|rootPos.board[crosses]) & move)==0x000)
             	{
              	 rootPos.board[rootPos.side] |= move;
               	 rootPos.side=!rootPos.side;
               	 drawBoard();
               	 if (sideWon==-1) rootSearch(&rootPos);
               	 drawBoard();
             	}           
            break;            
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}
